#if defined(ARDUINO) && ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
  #include <pins_arduino.h>
#endif

#include "ledCandleClass.h"

ledCandle::ledCandle (int _ledPin)
{
  pinMode(_ledPin, OUTPUT);
  ledPin = _ledPin;
  minPWM = 10;
  maxPWM = 250;
  minDelayMS = 1;
  maxDelayMS = 13;
  currentDelayMS = 20;
  currentPWM = 100;
  targetPWM = 20;
  lastMillis = 0;
}

ledCandle::ledCandle (int _ledPin, int _maxPWM)
{
  pinMode(_ledPin, OUTPUT);
  ledPin = _ledPin;
  minPWM = 10;
  maxPWM = _maxPWM;
  minDelayMS = 1;
  maxDelayMS = 13;
  currentDelayMS = 20;
  currentPWM = 100;
  targetPWM = 20;
  lastMillis = 0;
}

void ledCandle::updateLedCandle(void)
{
    if (millis() - lastMillis < currentDelayMS) return;

    lastMillis = millis();
    analogWrite(ledPin, currentPWM);

    if (currentPWM < targetPWM) currentPWM++;
    else if (currentPWM > targetPWM) currentPWM--;
    else
    {
        currentDelayMS = random(minDelayMS, maxDelayMS);
        targetPWM = random(minPWM, maxPWM);
    }
}
